diff --git a/handlers/Config.in b/handlers/Config.in
index 14f8af9..ad5dfdd 100644
--- a/handlers/Config.in
+++ b/handlers/Config.in
@@ -9,67 +9,31 @@
 
 menu "Image Handlers"
 
-config UBIVOL
-	bool "ubivol"
+config ARCHIVE
+	bool "archive"
+	depends on HAVE_LIBARCHIVE
 	default n
-	depends on HAVE_LIBUBI
-	depends on MTD
 	help
-	  ubi is the default format for NAND device.
-	  Say Y if you have NAND or you use UBI on
-	  your system.
+	  Handler using the libarchive to extract tarballs
+	  into a filesystem.
 
-comment "ubivol support needs libubi"
-	depends on !HAVE_LIBUBI
+comment "archive support needs libarchive"
+	depends on !HAVE_LIBARCHIVE
 
-config UBIATTACH
-	bool "Automatically attach UBI devices"
+config LOCALE
+	bool "Locale support for filenames"
+	depends on ARCHIVE
 	default y
-	depends on UBIVOL
-	help
-	  If this option is enabled, swupdate will try to attach
-	  UBI devices to all MTD devices.
-
-	  Make sure UBIBLACKLIST or UBIWHITELIST is set correctly,
-	  since attaching a UBI device will write to it if it is
-	  found to be empty, and that may destroy already existing
-	  content on that device.
-
-config UBIBLACKLIST
-	string "List of MTD devices to be excluded for UBI"
-	depends on UBIATTACH
-	help
-	  Define a list of MTD devices that are excluded
-	  by scan_mtd_device. The devices are still available
-	  as raw devices.
-	  The list can be set as a string with the mtd numbers.
-	  Examples: "0 1 2"
-	  This excludes mtd0-mtd1-mtd2 to be searched for UBI volumes
-
-config UBIWHITELIST
-	string "List of MTD devices that must have UBI"
-	depends on UBIATTACH
 	help
-	  Define a list of MTD devices that are planned to have
-	  always UBI. If first attach fails, the device is erased
-	  and tried again.
-	  The list can be set as a string with the mtd numbers.
-	  Examples: "0 1 2"
-	  This sets mtd0-mtd1-mtd2 to be used as UBI volumes.
-	  UBIBLACKLIST has priority on UBIWHITELIST.
+	  Option to remove attempts to use locale in systems
+	  without locale support in toolchain.
 
-config UBIVIDOFFSET
-	int "VID Header Offset"
-	depends on UBIATTACH
-	default 0
+config BOOTLOADERHANDLER
+	bool "bootloader"
+	default n
 	help
-	  Force UBI to set a VID header offset to be 2048 bytes
-	  instead of the value reported by the kernel.
-	  In other words, you may ask UBI to avoid using sub-pages.
-	  This is not recommended since this will require
-	  more storage overhead, but may be useful
-	  if your NAND driver incorrectly reports that it can handle
-	  sub-page accesses when it should not.
+	  Enable it to change bootloader environment
+	  during the installation process.
 
 config CFI
 	bool "cfi"
@@ -124,53 +88,6 @@ config DISKFORMAT_HANDLER
 
 source fs/Config.in
 
-config UNIQUEUUID
-	bool "uniqueuuid"
-	depends on HAVE_LIBBLKID
-	default n
-	help
-	  This handler checks that no filesystem on the device has
-	  a UUID from a list (list is added as part of "properties"
-	  in sw-description) for this handler.
-	  This is useful for bootloader (like GRUB) that use UUID to
-	  select the partition to be started, and in case two or
-	  more filesystem have the same UUID, a wrong one is started.
-	  This handler is a partition handler and it is guaranteed that
-	  it runs before any image is installed on the device.
-
-comment "uniqueuuid support needs libblkid"
-	depends on !HAVE_LIBBLKID
-
-config RAW
-	bool "raw"
-	default n
-	help
-	  This is a simple handler that simply copies
-	  into the destination.
-
-config RDIFFHANDLER
-	bool "rdiff"
-	depends on HAVE_LIBRSYNC
-	default n
-	help
-	  Add support for applying librsync's rdiff patches,
-	  see http://librsync.sourcefrog.net/
-
-comment "rdiff support needs librsync"
-	depends on !HAVE_LIBRSYNC
-
-config READBACKHANDLER
-	bool "readback"
-	depends on HASH_VERIFY
-	default n
-	help
-	  To verify that an image was written properly, this readback handler
-	  calculates the sha256 hash of a partition (or part of it) and compares
-	  it against a given hash value.
-
-	  This is a post-install handler running at the same time as
-	  post-install scripts.
-
 config LUASCRIPTHANDLER
 	bool "Lua Script"
 	depends on LUA
@@ -179,14 +96,6 @@ config LUASCRIPTHANDLER
 	  Handler to be called for pre- and post scripts
 	  written in Lua.
 
-config SHELLSCRIPTHANDLER
-	bool "shellscript"
-	default n
-	help
-	  Handler to be called for pre- and post scripts
-	  written as shell scripts. The default shell /bin/sh
-	  is called.
-
 config HANDLER_IN_LUA
 	bool "Handlers in Lua"
 	depends on LUASCRIPTHANDLER
@@ -219,24 +128,35 @@ config EMBEDDED_LUA_HANDLER_SOURCE
 	  Path to the Lua handler source code file to be
 	  embedded into the SWUpdate binary.
 
-config ARCHIVE
-	bool "archive"
-	depends on HAVE_LIBARCHIVE
+config RAW
+	bool "raw"
 	default n
 	help
-	  Handler using the libarchive to extract tarballs
-	  into a filesystem.
+	  This is a simple handler that simply copies
+	  into the destination.
 
-comment "archive support needs libarchive"
-	depends on !HAVE_LIBARCHIVE
+config RDIFFHANDLER
+	bool "rdiff"
+	depends on HAVE_LIBRSYNC
+	default n
+	help
+	  Add support for applying librsync's rdiff patches,
+	  see http://librsync.sourcefrog.net/
 
-config LOCALE
-	bool "Locale support for filenames"
-	depends on ARCHIVE
-	default y
+comment "rdiff support needs librsync"
+	depends on !HAVE_LIBRSYNC
+
+config READBACKHANDLER
+	bool "readback"
+	depends on HASH_VERIFY
+	default n
 	help
-	  Option to remove attempts to use locale in systems
-	  without locale support in toolchain.
+	  To verify that an image was written properly, this readback handler
+	  calculates the sha256 hash of a partition (or part of it) and compares
+	  it against a given hash value.
+
+	  This is a post-install handler running at the same time as
+	  post-install scripts.
 
 config REMOTE_HANDLER
 	bool "Remote handler"
@@ -253,6 +173,14 @@ config REMOTE_HANDLER
 comment "remote handler needs zeromq"
 	depends on !HAVE_LIBZEROMQ
 
+config SHELLSCRIPTHANDLER
+	bool "shellscript"
+	default n
+	help
+	  Handler to be called for pre- and post scripts
+	  written as shell scripts. The default shell /bin/sh
+	  is called.
+
 config SWUFORWARDER_HANDLER
 	bool "SWU forwarder"
 	depends on HAVE_LIBCURL
@@ -275,13 +203,6 @@ comment "swuforward handler needs json-c and libcurl"
 comment "swuforward handler needs websockets and uriparser"
 	depends on !HAVE_LIBWEBSOCKETS || !HAVE_URIPARSER
 
-config BOOTLOADERHANDLER
-	bool "bootloader"
-	default n
-	help
-	  Enable it to change bootloader environment
-	  during the installation process.
-
 config SSBLSWITCH
 	bool "Second Stage Switcher"
 	depends on MTD
@@ -293,6 +214,68 @@ config SSBLSWITCH
 	  way between two software set. It can be used to reliable update
 	  a second stage bootloader.
 
+config UBIVOL
+	bool "ubivol"
+	default n
+	depends on HAVE_LIBUBI
+	depends on MTD
+	help
+	  ubi is the default format for NAND device.
+	  Say Y if you have NAND or you use UBI on
+	  your system.
+
+comment "ubivol support needs libubi"
+	depends on !HAVE_LIBUBI
+
+config UBIATTACH
+	bool "Automatically attach UBI devices"
+	default y
+	depends on UBIVOL
+	help
+	  If this option is enabled, swupdate will try to attach
+	  UBI devices to all MTD devices.
+
+	  Make sure UBIBLACKLIST or UBIWHITELIST is set correctly,
+	  since attaching a UBI device will write to it if it is
+	  found to be empty, and that may destroy already existing
+	  content on that device.
+
+config UBIBLACKLIST
+	string "List of MTD devices to be excluded for UBI"
+	depends on UBIATTACH
+	help
+	  Define a list of MTD devices that are excluded
+	  by scan_mtd_device. The devices are still available
+	  as raw devices.
+	  The list can be set as a string with the mtd numbers.
+	  Examples: "0 1 2"
+	  This excludes mtd0-mtd1-mtd2 to be searched for UBI volumes
+
+config UBIWHITELIST
+	string "List of MTD devices that must have UBI"
+	depends on UBIATTACH
+	help
+	  Define a list of MTD devices that are planned to have
+	  always UBI. If first attach fails, the device is erased
+	  and tried again.
+	  The list can be set as a string with the mtd numbers.
+	  Examples: "0 1 2"
+	  This sets mtd0-mtd1-mtd2 to be used as UBI volumes.
+	  UBIBLACKLIST has priority on UBIWHITELIST.
+
+config UBIVIDOFFSET
+	int "VID Header Offset"
+	depends on UBIATTACH
+	default 0
+	help
+	  Force UBI to set a VID header offset to be 2048 bytes
+	  instead of the value reported by the kernel.
+	  In other words, you may ask UBI to avoid using sub-pages.
+	  This is not recommended since this will require
+	  more storage overhead, but may be useful
+	  if your NAND driver incorrectly reports that it can handle
+	  sub-page accesses when it should not.
+
 config UCFWHANDLER
 	bool "microcontroller firmware update"
 	depends on HAVE_LIBGPIOD
@@ -316,4 +299,21 @@ config UCFW_OLD_LIBGPIOD
 	  Rather there is no way to get this changes from the library
 	  at build time.
 
+config UNIQUEUUID
+	bool "uniqueuuid"
+	depends on HAVE_LIBBLKID
+	default n
+	help
+	  This handler checks that no filesystem on the device has
+	  a UUID from a list (list is added as part of "properties"
+	  in sw-description) for this handler.
+	  This is useful for bootloader (like GRUB) that use UUID to
+	  select the partition to be started, and in case two or
+	  more filesystem have the same UUID, a wrong one is started.
+	  This handler is a partition handler and it is guaranteed that
+	  it runs before any image is installed on the device.
+
+comment "uniqueuuid support needs libblkid"
+	depends on !HAVE_LIBBLKID
+
 endmenu